<script lang="ts" setup>
import { defineProps } from 'vue';
import {
  HandbookAlt,
  Document,
  DocumentsAlt,
  ChevronLgRight,
  AiValueStreamForecast,
  UserCollaboration,
  Handshake,
  Verification,
} from 'slippers-ui/icons';

const icons = {
  HandbookAlt,
  Document,
  DocumentsAlt,
  ChevronLgRight,
  AiValueStreamForecast,
  UserCollaboration,
  Handshake,
  Verification,
};

interface LearnMoreCard {
  type: string;
  icon: string;
  header: string;
  buttons?: {
    text: string;
    config: {
      href: string;
      icon?: string;
      dataGaName?: string;
      dataGaLocation?: string;
    };
  }[];
  config: {
    href: string;
  };
}

defineProps({
  header: {
    type: String,
    required: false,
    default: '',
  },
  cards: {
    type: Array as PropType<LearnMoreCard[]>,
    required: true,
  },
});
</script>

<template>
  <SlpContainer class="learn-more">
    <SlpTypography variant="heading3-bold">{{ header }}</SlpTypography>
    <div class="card-container">
      <div v-for="card in cards" :key="card.header" class="card">
        <div class="type">
          <SlpIcon :icon="icons[card.icon]" size="md" class="card__icon" />
          <SlpTypography variant="body2">{{ card.type }}</SlpTypography>
        </div>
        <SlpTypography variant="heading4-bold" tag="h4" class="title">{{ card.header }}</SlpTypography>
        <div class="slp-mt-32 slp-mt-md-96">
          <SlpButton
            v-for="button in card.buttons"
            :key="button.text"
            variant="tertiary"
            :href="button.config.href"
            :data-ga-name="button.dataGaName || button.text"
            :data-ga-location="button.dataGaLocation || 'learn-more'"
            >{{ button.text }}
            <SlpIcon :icon="icons[button.icon] || ChevronLgRight" class="slp-ml-16" />
          </SlpButton>
        </div>
      </div>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.learn-more {
  padding: 32px 16px;
  margin-bottom: 64px;
}
.card-container {
  display: grid;
  grid-template-columns: 1fr;
  gap: 16px;
  margin-top: 32px;
  @media (min-width: $breakpoint-lg) {
    grid-template-columns: 1fr 1fr 1fr;
  }
  & > :nth-child(1),
  & > :nth-child(2) {
    .slp-btn.slp-btn-tertiary {
      &:before {
        content: '';
        height: 100%;
        width: 100%;
        position: absolute;
        left: 0;
        top: 0;
      }
    }
  }
  & > :nth-child(3) {
    &:hover {
      border-radius: 4px !important;
      background: #fff !important;
      cursor: default;
    }
  }
  .card {
    display: flex;
    padding: 32px;
    flex-direction: column;
    align-items: flex-start;
    transition: all 0.3s ease-in;
    cursor: pointer;
    color: $color-text-300;
    border: 1px solid $color-surface-300;
    border-radius: 4px;
    position: relative;
    .title {
      flex-basis: 100%;
      margin-top: 16px;
    }
    .type {
      display: flex;
      flex-direction: row;
      align-items: center;
      gap: 16px;
    }
    &:hover {
      border-radius: 4px 4px 82px 4px;
      background: #f5f2fd;
    }
    &__icon {
      height: 24px;
      width: 24px;
    }
  }
}
</style>
